<?php

/**
 * This module checks if subfolders miss an index.php
 *
 * @module          check_folder_secure
 * @author          Wolfgang Studer
 * @copyright       2015-2015 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.03.000 | 2015-11-17
 */

// include class.secure.php to protect this file and the whole CMS!
if ( defined('LEPTON_PATH') == TRUE ):	
	include(LEPTON_PATH.'/framework/class.secure.php');
else:
	$oneback = "../";
	$root = $oneback;
	$level = 1;
	while (($level < 10) && (!file_exists($root.'/framework/class.secure.php'))):
		$root .= $oneback;
		$level += 1;
	endwhile;
	
	if (file_exists($root.'/framework/class.secure.php')):
		include($root.'/framework/class.secure.php');
	else:
		trigger_error(sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR);
	endif;
endif;
// end include class.secure.php


//Modul Description
$module_description = "This module shows folders with missing INDEX File.";

//Variables for the  backend
	$CHECKFOLDERSECURE['SUBMIT_ALL']	= "create ALL index" . PAGE_EXTENSION;
	$CHECKFOLDERSECURE['SUBMIT']		= "create index" . PAGE_EXTENSION;
	$CHECKFOLDERSECURE['CANCEL']		= "Back to the Admin Tools";

	$CHECKFOLDERSECURE['NODATA'] 		= "All OK, no folders found without an index file !";

	$CHECKFOLDERSECURE['TEMPLATE'] 		= "TEMPLATE Folder";
	$CHECKFOLDERSECURE['MEDIA'] 		= "MEDIA Folder";
	$CHECKFOLDERSECURE['PAGES'] 		= "SEITEN Folder(s)";
	$CHECKFOLDERSECURE['CORE'] 			= "LEPTON CMS CORE Folders";

	$CHECKFOLDERSECURE['HEADERHINT']	= "Folders without an index file can be a potential risk as visitor may get a file list or an info that he has no access to this folder."
										. '<br />'
										. 'Folders with index file shows your home page!'
										. '<br />'
										. '<br />'
										. 'Click on a link in the list below to see how it works on your side.';

?>
