<?php

/**
 * This module checks if subfolders miss an index.php
 *
 * @module          check_folder_secure
 * @author          Wolfgang Studer
 * @copyright       2015-2015 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.03.000 | 2015-11-17
 */

// include class.secure.php to protect this file and the whole CMS!
if ( defined('LEPTON_PATH') == TRUE ):	
	include(LEPTON_PATH.'/framework/class.secure.php');
else:
	$oneback = "../";
	$root = $oneback;
	$level = 1;
	while (($level < 10) && (!file_exists($root.'/framework/class.secure.php'))):
		$root .= $oneback;
		$level += 1;
	endwhile;
	
	if (file_exists($root.'/framework/class.secure.php')):
		include($root.'/framework/class.secure.php');
	else:
		trigger_error(sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR);
	endif;
endif;
// end include class.secure.php


	if ( !isset($admin) || !is_object($admin)) die();

// define module name
	$module_name = 'check_folder_secure';

// check if backend.css file needs to be included into the <body></body>
	if (( method_exists($admin, 'register_backend_modfiles') == FALSE ) && ( file_exists(LEPTON_PATH .'/modules/' . $module_name . '/backend.css') == TRUE )):
		echo '<style type="text/css">' . PHP_EOL;
		include( LEPTON_PATH . '/modules/' . $module_name . '/backend.css');
		echo PHP_EOL . "</style>" . PHP_EOL;
	endif;

// get leptoken
	$leptoken = (isset($_GET['leptoken']) ? "?leptoken=".$_GET['leptoken'] : "" );

// check if module language file exists for the language set by the user (e.g. DE, EN); fallback = EN
	$lang = dirname(__FILE__)."/languages/".LANGUAGE.".php";
	include( file_exists($lang) ? $lang : dirname(__FILE__)."/languages/EN.php" );

// include function library
	include("lib_functions.php");
	
// loop over all folders of LEPTON installation and find those without index.php
// this job must be done before $_POST processing is made!
	$folders = array();
	$directory = realpath( LEPTON_PATH );
	$searchFiles = array( 'index.html', 'index.htm', 'index.php' );

	$folders = recursiveDirectoryIterator ( $directory, $folders, $searchFiles );

	sort( $folders );


// generate output array
if (( isset($_POST['job']) ) && ($_POST['job'] == "create" )):

	$processed = array();

	// collect all
	if ( isset( $_POST['Sall'] ) == TRUE ):
		foreach ( $_POST as $key => $item ):
			if (( substr( $key, 0, 1 ) == "F" ) && ( is_numeric( substr( $key, 1 ) ) == TRUE )):
				$processed[ $key ] = $item;
			endif;
		endforeach;
	else:
		// loop over all items until you find one starting with an "S" followed by a number
		// then collect the corresponding item starting with an "F" followed by same number
		foreach ( $_POST as $key => $item ):
			if (( substr( $key, 0, 1 ) == "S" ) && ( is_numeric( substr( $key, 1 ) ) == TRUE )):
				$folderdKey = "F" . substr( $key, 1 );
				$processed[ $folderdKey ] = $_POST[ $folderdKey ];
				break;
			endif;
		endforeach;
	endif;

	// process collected folders
	if ( count( $processed ) > 0 ):
		// Open the file to get existing content
		$SourceFile = dirname(__FILE__) . DIRECTORY_SEPARATOR . 'templates' . DIRECTORY_SEPARATOR . 'index.tpl';
		$fileContent = file_get_contents($SourceFile);
		$fileContent = str_replace( '##DATE##', date(DATE_RFC822), $fileContent );
		
		foreach ( $processed as $key => $item ):
			// Write the contents back to the target file
			$targetFile = $item . DIRECTORY_SEPARATOR . 'index' . PAGE_EXTENSION;
			file_put_contents( $targetFile, $fileContent );
		endforeach;
	endif;
endif;

?>

<a class="envinfo_anchor" id="TOP"></a>

<form id="envinfo_form" style="margin-top: 1em;" action="" method="post">
    <input type="hidden" name="job" value="create" />
	<table cellpadding="0" cellspacing="0" border="0" width="100%">

<?php
	$dataFound = FALSE;

	$groups = array();
	$groups[] = 'templates';
	$output = showFolderGroup ( 'template', $folders );
	
	if (( $dataFound == FALSE ) && ( strlen( $output ) > 0 )):
		echo showHeader();
		$dataFound = TRUE;
	endif;
	echo $output;

	$groups = array();
	$groups[] = str_replace( DIRECTORY_SEPARATOR, '', MEDIA_DIRECTORY );
	$output = showFolderGroup ( 'media', $folders );
	
	if (( $dataFound == FALSE ) && ( strlen( $output ) > 0 )):
		echo showHeader();
		$dataFound = TRUE;
	endif;
	echo $output;

	$groups = array();
	$groups[] = 'account';
	$groups[] = 'admins';
	$groups[] = 'framework';
	$groups[] = 'include';
	$groups[] = 'install';
	$groups[] = 'languages';
	$groups[] = 'modules';
	$groups[] = 'search';
	$groups[] = 'temp';
	$groups[] = basename( ADMIN_PATH );	// for those haveing ADMIN_PATH changed
	$output = showFolderGroup ( 'core', $folders );
	
	if (( $dataFound == FALSE ) && ( strlen( $output ) > 0 )):
		echo showHeader();
		$dataFound = TRUE;
	endif;
	echo $output;

	$groups = array();
	$groups[] = '*';
	$output = showFolderGroup ( 'pages', $folders );
	
	if (( $dataFound == FALSE ) && ( strlen( $output ) > 0 )):
		echo showHeader();
		$dataFound = TRUE;
	endif;
	echo $output;

	// no data found	
	if ( $dataFound == FALSE ):
		echo '		<tr>' . PHP_EOL;
		echo '			<td colspan="4"><p class="nodata">' . $CHECKFOLDERSECURE['NODATA'] . '</p></td>' . PHP_EOL;
		echo '		</tr>' . PHP_EOL;
	endif;

?>

 		<tr>
			<td colspan="4">&nbsp;</td>
		</tr>
 		<tr>
			<td>
				<input type="button" value="<?php echo $CHECKFOLDERSECURE['CANCEL']; ?>" onclick="document.location='<?php echo ADMIN_URL; ?>/admintools/index.php<?php echo $leptoken; ?>';" />
			</td>
			<td>&nbsp;</td>
			<td>&nbsp;</td>
			<td>
<?php
	if ( $dataFound == FALSE ):
		echo '&nbsp;' . PHP_EOL;
	else:
?>
				<input type="submit" name="Sall" value="<?php echo $CHECKFOLDERSECURE['SUBMIT_ALL']; ?>" />
<?php endif; ?>
			</td>
		</tr>
 		<tr>
			<td colspan="4">&nbsp;</td>
		</tr>
 		<tr>
			<td colspan="4"><hr /></td>
		</tr>
	</table>
</form>
